var Ger01100_Transportadora_Service = function (General,Ger01100_Transportadora_Repository, ScreenService) {

    this.validateNumeroDeInscricao = function(inputValue) {
        var inscricao = General.inscricaoFormat(inputValue);
        if(!inscricao.valid) {
            //build appropriated error messages
            inscricao.error = {};
            var var_invalido =  ScreenService.i18n(" inválido!");
            var var_invalida =  ScreenService.i18n(" inválida!");
            switch(inscricao.tipo.cod) {
                case 'J':
                    inscricao.error.msg = "CNPJ \"" + inscricao.value + "\"" + var_invalido ;
                    break;
                case 'F':
                    inscricao.error.msg = "CPF \"" + inscricao.value + "\"" + var_invalido;
                    break;
                case null:
                    break;
                case 'I':
                /* falls through */
                default:
                    inscricao.error.msg = inscricao.tipo.desc + " \"" + inscricao.value + "\"" + var_invalida;
            }
        }
        return inscricao;
    };

    this.salvarTransportadora = function(row){
        return Ger01100_Transportadora_Repository.saveTransportadora(row);
    };
    this.buscarParceiro = function(row){
        return Ger01100_Transportadora_Repository.findParceiro(row);

    };
    this.removerMacaras= function(row){
        if(row.NRINSJURTRAN){
            row.NRINSJURTRAN =row.NRINSJURTRAN.replace(/[^0-9]/g,'');
        }
        if(row.NRTELETRAN){
            row.NRTELETRAN =row.NRTELETRAN.replace(/[^0-9]/g,'');
        }
        if(row.NRFAXTRAN){
            row.NRFAXTRAN =row.NRFAXTRAN.replace(/[^0-9]/g,'');
        }
        if(row.NRTELEXTRAN){
            row.NRTELEXTRAN =row.NRTELEXTRAN.replace(/[^0-9]/g,'');
        }
        if(row.NRCEPTRAN){
           row.NRCEPTRAN =row.NRCEPTRAN.replace(/[^0-9]/g,'');
        }
    };


};

Configuration(function(ContextRegister){
    ContextRegister.register('Ger01100_Transportadora_Service', Ger01100_Transportadora_Service);
});