var Ped02100_modalidadePagamento_Controller = function(General, templateManager, ScreenService) {
    
    this.validaCamposAtivos = function(){
        
        var widget = templateManager.container.getWidget('widgetModalidadePagamentoForm');

        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
        
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
            
        var idtpforpgtomod = widget.currentRow.IDTPFORPGTOMOD;
            
            switch (idtpforpgtomod) {
                case 'X':
                    widget.getField('NRDIAPGFIXMOD').readOnly = true;
                    widget.getField('NRPARCPGTOMOD').readOnly = true;
                    widget.getField('IDUTDIAPAGMOD').readOnly = true;
                    widget.getField('NMFORMPGTO').readOnly = true;
                    widget.currentRow.NRDIAPGFIXMOD = 0;
                    widget.currentRow.NRPARCPGTOMOD = 0;
                    widget.currentRow.IDUTDIAPAGMOD = "I";
                    widget.currentRow.NMFORMPGTO = "";
                    widgetPrazo.isVisible = false;
                    widget.getAction('novoPrazo').isVisible = false;
                    if(widget.getField('NMFORMPGTO').validations){
                        delete(widget.getField('NMFORMPGTO').validations);
                    }
                    break;
                case 'F':
                    widget.getField('NRDIAPGFIXMOD').readOnly = false;
                    widget.getField('NRPARCPGTOMOD').readOnly = false;
                    widget.getField('IDUTDIAPAGMOD').readOnly = false;
                    widget.getField('NMFORMPGTO').readOnly = true;
                    widget.currentRow.NRDIAPGFIXMOD = 1;
                    widget.currentRow.NRPARCPGTOMOD = 1;
                    widget.currentRow.NMFORMPGTO = "";
                    widgetPrazo.isVisible = false;
                    widget.getAction('novoPrazo').isVisible = false;
                    if(widget.getField('NMFORMPGTO').validations){
                        delete(widget.getField('NMFORMPGTO').validations);
                    }
                    break;
                case 'V':
                    widget.getField('NRDIAPGFIXMOD').readOnly = true;
                    widget.getField('NRPARCPGTOMOD').readOnly = true;
                    widget.getField('IDUTDIAPAGMOD').readOnly = true;
                    widget.currentRow.NRDIAPGFIXMOD = 0;
                    widget.currentRow.NRPARCPGTOMOD = 0;
                    widget.currentRow.IDUTDIAPAGMOD = "I";
                    widget.getAction('novoPrazo').isVisible = true;
                    widget.getField('NMFORMPGTO').readOnly = false;
                    widget.getField('NMFORMPGTO').validations = {required: true};
                    widgetPrazo.isVisible = true;
                    this.consultaPrazo(widgetModPrincipal,widget,widgetPrazo);
                    this.editPrazo();
                    widget.activate();
                    break;
                default:
            }
            
            templateManager.updateTemplate();
        

    };
    
    this.editPrazo = function() {

        var widgetModForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');

        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');

        var idtpforpgtomod = widgetModForm.currentRow.IDTPFORPGTOMOD;

        if(widgetModForm.mode == "edit" && idtpforpgtomod == 'V') {

            widgetPrazo.fields[1].inlineEditable = true;
            
            widgetPrazo.fields[2].inlineEditable = true;
            
            widgetPrazo.getAction('excluirPrazo').isVisible = true;
            
            widgetPrazo.inlineEdit();
            
            this.resetWidget(widgetPrazo);
                
        } else if(idtpforpgtomod != 'V') {

            widgetPrazo.fields[1].inlineEditable = false;
            
            widgetPrazo.fields[2].inlineEditable = false;
            
            widgetPrazo.getAction('excluirPrazo').isVisible = false;
            
            widgetPrazo.inlineEdit();
            
            this.resetWidget(widgetPrazo);
        
        }

    };
    
    this.validaValorMax = function(args){
        if(args.row.VRPEDESMODPG >= 100){
            ScreenService.showMessage("Percentual de Desconto deve estar entre 0,01 e 99,99%.");
            args.row.VRPEDESMODPG = "";
        }
    };
    
    this.validaDataMax = function(args){
        if((args.row.NRDIAPGFIXMOD > 31) || (args.row.NRDIAPGFIXMOD < 1)){
            ScreenService.showMessage("Dia deve estrar entre 1 e 31.");
            args.row.NRDIAPGFIXMOD = "";
        }
    };
    
    this.validaParcelaMax = function(args){
        if((args.row.NRPARCPGTOMOD > 99) || (args.row.NRPARCPGTOMOD < 1)){
            ScreenService.showMessage("Quantidade de parcelas deve estar entre 1 e 99.");
            args.row.NRPARCPGTOMOD = "";
        }
    };
    
    this.saveModalidade = function(){
        
        var sucesso = false;
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
        var widgetModForm = templateManager.container.getWidget("widgetModalidadePagamentoForm");
        var widgetPrazo = templateManager.container.getWidget("widgetModPrazoPed");
        var id = widgetModForm.currentRow.IDTPFORPGTOMOD;
        var porcentagem = 0;
        
        if(id == 'X'){
            widgetModForm.currentRow.IDTPFORPGTOMOD = "";
        }
        
        if(id == 'V') {
        
            var dados = widgetPrazo.dataSource.data;
            
            dados.map(function(prazo){
               
               porcentagem += parseFloat(prazo.VRPERCMODPGTO);
                
            }.bind(this));
            
        }
        
        if(porcentagem == 100 && id == 'V') {
        
            sucesso = true;
        
            var dataSet = [];
        
            dataSet[0] = [widgetModForm.currentRow];
            
            dataSet[1] = [];
            
            widgetPrazo.dataSource.data.forEach(function(e){
                
                e.CDMODPGTO = dataSet[0][0].CDMODPGTO;
                
                dataSet[1].push(Util.clone(e, ['__leftActions', '__rightActions']));
                
            }.bind(this));
        
            General.callRestEngine('ped_pedidos#/saveModalidade', 'DataSet', dataSet).then(function(sucess){
                
                ScreenService.showMessage('Modalidade Salva').then(function(){
                   this.sucessoFunction(); 
                }.bind(this));
                
            }.bind(this),function(fail){
                
                ScreenService.showMessage(fail.error);
                
            }.bind(this));
            
        } else if(id == 'V' && porcentagem !== 100) {
            
            sucesso = false;
            
            ScreenService.showMessage('Percentual dos Prazos esta diferente de 100%');
            
        } else if(id !== 'V') {
           
            sucesso = true;
            
            General.saveCrud(widgetModForm).then(function(){
               
                if((id !== 'F') && (id !== 'V')){
                    widgetModForm.currentRow.IDTPFORPGTOMOD = 'X';
                }
                
                ScreenService.showMessage("Modalidade salva").then(function(){
                   this.sucessoFunction(); 
                }.bind(this));
            
            }.bind(this), function (error) {
               
                ScreenService.showMessage(error);
            
            }.bind(this));
        
        }
        
        /*if(sucesso) {
            
            General.widgetCancelForm(widgetModForm);
            
            widgetModForm.activate();
            
            templateManager.updateTemplate();
            
            widgetPrazo.fields[1].inlineEditable = false;
            
            widgetPrazo.fields[2].inlineEditable = false;
            
            widgetPrazo.getAction('excluirPrazo').isVisible = false;
            
            this.resetWidget(widgetPrazo);
            
            widgetModPrincipal.activate();
            
            templateManager.updateTemplate();
            
            ScreenService.goBack();
            
            widgetModPrincipal.reload();
            
            sucesso = false;
            
        }*/

    };
    
    this.sucessoFunction = function(){
            var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
            var widgetModForm = templateManager.container.getWidget("widgetModalidadePagamentoForm");
            var widgetPrazo = templateManager.container.getWidget("widgetModPrazoPed");
           
            General.widgetCancelForm(widgetModForm);
            widgetModForm.activate();
            templateManager.updateTemplate();
            widgetPrazo.fields[1].inlineEditable = false;
            widgetPrazo.fields[2].inlineEditable = false;
            widgetPrazo.getAction('excluirPrazo').isVisible = false;
            this.resetWidget(widgetPrazo);
            widgetModPrincipal.activate();
            templateManager.updateTemplate();
            ScreenService.goBack();
            widgetModPrincipal.reload();
            
    };
    
    this.removerModalidade = function() {
      
      var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
      var widgetModForm = templateManager.container.getWidget("widgetModalidadePagamentoForm");
      var widgetPrazo = templateManager.container.getWidget("widgetModPrazoPed");
      
       var dataSet = [];
        
            dataSet[0] = [widgetModForm.currentRow];
            
            dataSet[1] = [];
            
            widgetPrazo.dataSource.data.forEach(function(e){
                
                e.CDMODPGTO = dataSet[0][0].CDMODPGTO;
                
                dataSet[1].push(Util.clone(e, ['__leftActions', '__rightActions']));
                
            }.bind(this));
        
            General.callRestEngine('ped_pedidos#/deletaModalidade', 'DataSet', dataSet).then(function(sucess){
                
                ScreenService.showMessage('Modalidade Removida').then(function(){
                    widgetModPrincipal.reload();
                });
                
            }.bind(this),function(fail){
                
                ScreenService.showMessage(fail.error);
                
            }.bind(this));
            
       ScreenService.goBack();
        
    };
    
    this.editForm = function() {
        
        var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
        
        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
        
        var widgetModalidadeDash = templateManager.container.getWidget('modPagDash');
        
        General.widgetEdit(widgetModadalidadeForm);
        
        var idtpforpgtomod = widgetModadalidadeForm.currentRow.IDTPFORPGTOMOD;
        
        if(widgetPrazo.isVisible && idtpforpgtomod == 'V') {
            
            widgetPrazo.fields[1].inlineEditable = true;
            
            widgetPrazo.fields[2].inlineEditable = true;
            
            widgetPrazo.getAction('excluirPrazo').isVisible = true;
            
            widgetPrazo.inlineEdit();
            
            this.resetWidget(widgetPrazo);
            
        }
        
        widgetModalidadeDash.activate();
        
        templateManager.updateTemplate();
        
        widgetModadalidadeForm.activate();
        
        templateManager.updateTemplate();
    
    };
    
    this.resetWidget = function(widget) {
        
        widget.isVisible = false;
            
        widget.reload().then(function(){
            
            widget.isVisible = true;
    
            templateManager.updateTemplate();
        }.bind(this));
        
    };
    
    this.adicionaPrazo = function() {
      
       var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
       
       widgetPrazo.newRow();
        
    };
    
    
    this.deletaPrazo = function(row){
        
        var widget = templateManager.container.getWidget('widgetModPrazoPed');
        
        ScreenService.showCustomDialog('Deseja excluir o prazo?', 'question', 'question', [{
            label: ScreenService.i18n("Sim"),
            code: function(){
               
               if(row.__is_new){
                   
                   widget.dataSource.data.splice(widget.dataSource.data.indexOf(row), 1);
                   
               } else {
                   
                   var dataRow = Util.clone(row, ['__leftActions', '__rightActions']);
                   
                   General.callRestEngine('ped_pedidos#/deletaPrazoModalidade', 'Row', dataRow).then(function(sucess){
                       
                        ScreenService.showMessage('Prazo Deletado');
                        
                        widget.dataSource.data.splice(widget.dataSource.data.indexOf(row), 1);
                       
                   }.bind(this), function(fail){
                       
                       ScreenService.showMessage(fail);
                       
                   }.bind(this));
                   
               }
                    
                
            }.bind(this)
        },{
            label: ScreenService.i18n("Não"),
            code: function(){}.bind(this)
        }]);
        
    };
    
    this.cancelEditForm = function() {
      
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
        
        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
      
        var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
         
        var widgetModalidadeDash = templateManager.container.getWidget('modPagDash');
        
        General.widgetCancelForm(widgetModadalidadeForm);
            
        widgetPrazo.fields[1].inlineEditable = false;
        
        widgetPrazo.fields[2].inlineEditable = false;
        
        widgetPrazo.getAction('excluirPrazo').isVisible = false;
        
        this.resetWidget(widgetPrazo);
        
        widgetModalidadeDash.activate();
        
        templateManager.updateTemplate();
        
        widgetModadalidadeForm.activate();
        
        templateManager.updateTemplate();
        
        if(widgetModadalidadeForm.currentRow.__is_new) {
            
            ScreenService.goBack();
            
            widgetModPrincipal.activate();
        
            templateManager.updateTemplate();
            
        }
        
    };
    
    this.focaModForm = function() {
        
         var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
         
         widgetModadalidadeForm.activate();
        
    };
    
    this.abrirModalidadeForm = function() {
     
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
     
        var widgetTabbedModPag = templateManager.container.getWidget("tabbedModPag");
      
        var widgetModalidadeDash = templateManager.container.getWidget('modPagDash');
      
        var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
      
        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');
        
            ScreenService.openSwipe(widgetTabbedModPag).then(function() {
          
                widgetModadalidadeForm.currentRow = widgetModPrincipal.currentRow;
                
                this.validaCamposAtivos();
                  
                widgetModadalidadeForm.view();
                  
                widgetModalidadeDash.activate();
                   
                widgetModadalidadeForm.activate();
                
                widgetPrazo.activate();
                
                widgetModadalidadeForm.activate();
                   
                templateManager.updateTemplate();
           
      }.bind(this));
        
    };
    
    this.consultaPrazo = function(widgetPrincipal, widgetForm ,widgetPrazo) {
        
        widgetPrazo.dataSourceFilter[0].name = 'CDMODPGTO';
        widgetPrazo.dataSourceFilter[0].operator = '=';
        widgetPrazo.dataSourceFilter[0].value = widgetPrincipal.currentRow.CDMODPGTO;
        
        widgetPrazo.activate();
        
        this.resetWidget(widgetPrazo);
        
        widgetForm.activate();
        
    };
    
    this.adicionarModalidade = function(){
      
        var widgetModPrincipal = templateManager.container.getWidget("modalidadePagamento");
      
        var widgetTabbedModPag = templateManager.container.getWidget("tabbedModPag");
        
        var widgetModalidadeDash = templateManager.container.getWidget('modPagDash');
      
        var widgetModadalidadeForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
      
        var widgetPrazo = templateManager.container.getWidget('widgetModPrazoPed');

        widgetModPrincipal.currentRow = {};
        
        widgetPrazo.dataSource.data = [];
        
        widgetPrazo.isVisible = false;
            
        widgetPrazo.fields[1].inlineEditable = true;
            
        widgetPrazo.fields[2].inlineEditable = true;
            
        widgetPrazo.getAction('excluirPrazo').isVisible = true;
      
        ScreenService.openSwipe(widgetTabbedModPag).then(function(){
            
            General.widgetEdit(widgetModadalidadeForm);
            
            widgetModadalidadeForm.newRow();
        
            widgetModalidadeDash.activate();
            
            templateManager.updateTemplate();
            
            widgetModadalidadeForm.activate();
            
            templateManager.updateTemplate();
             
         }.bind(this));
    
            
    };
    
    this.fecharModalidadeForm = function(){
      
      var widgetModalidade = templateManager.container.getWidget('modalidadePagamento');
      
      var widgetForm = templateManager.container.getWidget('widgetModalidadePagamentoForm');
      
      widgetModalidade.activate = true;
      
      widgetForm.activate = false;
      
      widgetForm.habilitado = false;
      
      ScreenService.closeSwipe();
      
        
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('Ped02100_modalidadePagamento_Controller', Ped02100_modalidadePagamento_Controller);
});